/*
 * Universal REST API
 *
 * Universal API provides a RESTful and uniform way to access blockchain resources, with a rich and reusable model across multiple protocols/cryptocurrencies.  [Documentation](https://app.blockdaemon.com/docs/ubiquity)  ### Currently supported protocols:  * algorand   * mainnet * bitcoin   * mainnet/testnet * bitcoincash   * mainnet/testnet * dogecoin   * mainnet/testnet * ethereum   * mainnet/goerli * litecoin   * mainnet/testnet * near   * mainnet/testnet * oasis   * mainnet * optimism   * mainnet * polkadot   * mainnet/westend * polygon   * mainnet * solana   * mainnet/testnet * stellar   * mainnet/testnet * tezos   * mainnet * xrp   * mainnet  ##### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested, and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available.
 *
 * API version: 3.0.0
 * Contact: support@blockdaemon.com
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package ubiquity

import (
	"encoding/json"
)

// BlockIdentifiers struct for BlockIdentifiers
type BlockIdentifiers struct {
	// Number of items in block identifiers
	Total *int32             `json:"total,omitempty"`
	Data  *[]BlockIdentifier `json:"data,omitempty"`
	Meta  NullableMeta       `json:"meta,omitempty"`
}

// NewBlockIdentifiers instantiates a new BlockIdentifiers object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewBlockIdentifiers() *BlockIdentifiers {
	this := BlockIdentifiers{}
	return &this
}

// NewBlockIdentifiersWithDefaults instantiates a new BlockIdentifiers object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewBlockIdentifiersWithDefaults() *BlockIdentifiers {
	this := BlockIdentifiers{}
	return &this
}

// GetTotal returns the Total field value if set, zero value otherwise.
func (o *BlockIdentifiers) GetTotal() int32 {
	if o == nil || o.Total == nil {
		var ret int32
		return ret
	}
	return *o.Total
}

// GetTotalOk returns a tuple with the Total field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BlockIdentifiers) GetTotalOk() (*int32, bool) {
	if o == nil || o.Total == nil {
		return nil, false
	}
	return o.Total, true
}

// HasTotal returns a boolean if a field has been set.
func (o *BlockIdentifiers) HasTotal() bool {
	if o != nil && o.Total != nil {
		return true
	}

	return false
}

// SetTotal gets a reference to the given int32 and assigns it to the Total field.
func (o *BlockIdentifiers) SetTotal(v int32) {
	o.Total = &v
}

// GetData returns the Data field value if set, zero value otherwise.
func (o *BlockIdentifiers) GetData() []BlockIdentifier {
	if o == nil || o.Data == nil {
		var ret []BlockIdentifier
		return ret
	}
	return *o.Data
}

// GetDataOk returns a tuple with the Data field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BlockIdentifiers) GetDataOk() (*[]BlockIdentifier, bool) {
	if o == nil || o.Data == nil {
		return nil, false
	}
	return o.Data, true
}

// HasData returns a boolean if a field has been set.
func (o *BlockIdentifiers) HasData() bool {
	if o != nil && o.Data != nil {
		return true
	}

	return false
}

// SetData gets a reference to the given []BlockIdentifier and assigns it to the Data field.
func (o *BlockIdentifiers) SetData(v []BlockIdentifier) {
	o.Data = &v
}

// GetMeta returns the Meta field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *BlockIdentifiers) GetMeta() Meta {
	if o == nil || o.Meta.Get() == nil {
		var ret Meta
		return ret
	}
	return *o.Meta.Get()
}

// GetMetaOk returns a tuple with the Meta field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *BlockIdentifiers) GetMetaOk() (*Meta, bool) {
	if o == nil {
		return nil, false
	}
	return o.Meta.Get(), o.Meta.IsSet()
}

// HasMeta returns a boolean if a field has been set.
func (o *BlockIdentifiers) HasMeta() bool {
	if o != nil && o.Meta.IsSet() {
		return true
	}

	return false
}

// SetMeta gets a reference to the given NullableMeta and assigns it to the Meta field.
func (o *BlockIdentifiers) SetMeta(v Meta) {
	o.Meta.Set(&v)
}

// SetMetaNil sets the value for Meta to be an explicit nil
func (o *BlockIdentifiers) SetMetaNil() {
	o.Meta.Set(nil)
}

// UnsetMeta ensures that no value is present for Meta, not even an explicit nil
func (o *BlockIdentifiers) UnsetMeta() {
	o.Meta.Unset()
}

func (o BlockIdentifiers) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Total != nil {
		toSerialize["total"] = o.Total
	}
	if o.Data != nil {
		toSerialize["data"] = o.Data
	}
	if o.Meta.IsSet() {
		toSerialize["meta"] = o.Meta.Get()
	}
	return json.Marshal(toSerialize)
}

type NullableBlockIdentifiers struct {
	value *BlockIdentifiers
	isSet bool
}

func (v NullableBlockIdentifiers) Get() *BlockIdentifiers {
	return v.value
}

func (v *NullableBlockIdentifiers) Set(val *BlockIdentifiers) {
	v.value = val
	v.isSet = true
}

func (v NullableBlockIdentifiers) IsSet() bool {
	return v.isSet
}

func (v *NullableBlockIdentifiers) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableBlockIdentifiers(val *BlockIdentifiers) *NullableBlockIdentifiers {
	return &NullableBlockIdentifiers{value: val, isSet: true}
}

func (v NullableBlockIdentifiers) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableBlockIdentifiers) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
